import { descending, max } from 'd3';

export const getTop10BarData = (data) => {
  
	const stateTotals = {};
  
  const stateTotal = data
    .filter(d => d['ILITOTAL'] !== 'X')
    .filter(d => d['YEAR'] === '2018')
    .map(d => {
      d.value = +d['ILITOTAL'];
      if(!stateTotals[d['REGION']]) {
        stateTotals[d['REGION']] = 0;
      }
      stateTotals[d['REGION']] += d.value;
      return d;
    });

  const topStates = {};
  
   Object.entries(stateTotals)
     .map(([state, total]) => ({state, total}))
     .sort((a, b) => descending(a.total, b.total))
     .slice(0, 10)
     .forEach(d => topStates[d.state] = true);
  
  const topData = data.filter(d => topStates[d['State']]);
  
  const topStateSum = {};
  
  const topStateSum1 = topData
    .filter(d => d['ILITOTAL'] !== 'X')
//    .filter(d => d['YEAR'] === '2018')
    .filter(d => d['YEAR'] === '2019')
    .map(d => {
      d.value = +d['ILITOTAL'];
      if(!topStateSum[d['REGION']]) {
        topStateSum[d['REGION']] = 0;
      }
      topStateSum[d['REGION']] += d.value;
      return d;
    });

// for (let [key, value] of Object.entries(topStateSum)) {
//   console.log(`${key}: ${value}`);
// }

  const arrayToObject = (array, keyField) =>
   array.reduce((obj, item) => {
     obj[item[keyField]] = item
     return obj
   }, {});
  
  //Not working!
//const peopleObject = arrayToObject(topStateSum, "id");
//console.log(peopleObject);
  
  //reduce data 
  //const nationalData = data.filter(d => d['Week']);
  console.log(topStateSum1);

  const top10BarData = Object.entries(topStateSum)
     .map(([state, total]) => ({'State':state, 'Tvalue':total}))
     .sort((a, b) => descending(a.Tvalue, b.Tvalue));
  
    return top10BarData;
};
